/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://kenai.com/hg/openbluesky~src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.netbeans.nodes.role.impl;

import javax.annotation.Nonnull;
import java.util.List;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Node;
import it.tidalwave.role.Composite;
import it.tidalwave.netbeans.nodes.GenericNode;

/*********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class CompositeChildFactory extends ChildFactory<Object> // FIXME: SafeChildFactory?
  {
    @Nonnull
    private final Composite<?, ?> composite;

    public CompositeChildFactory (final @Nonnull Composite<?, ?> composite) 
      {
        this.composite = composite;
      }

    @Override
    protected boolean createKeys (final @Nonnull List<Object> toPopulate) 
      {
        toPopulate.addAll(composite.findChildren().results());            
        return true;
      }

    @Override @Nonnull
    protected Node createNodeForKey (final @Nonnull Object key) 
      {
        return new GenericNode(key);
      }
  }
